<!doctype html>
<html>
<head>
    <title>Tor 0.2.2.18-alpha available | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="Tor 0.2.2.18-alpha available | Tor Project">
    <meta property="og:description" content="Tor 0.2.2.18-alpha fixes several crash bugs that have been nagging us lately, makes unpublished...">
    <meta property="og:image" content="https://blog.torproject.org/static/images/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/tor-02218-alpha-available/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        Tor 0.2.2.18-alpha available
      </h1>
    <p class="meta">by phobos | November 17, 2010</p>
    <picture>
      <source media="(min-width:415px)" srcset="../static/images/lead.webp" type="image/webp">
<source srcset="../static/images/lead_small.webp" type="image/webp">

      <img class="lead" src="../static/images/lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>Tor 0.2.2.18-alpha fixes several crash bugs that have been nagging us lately, makes unpublished bridge relays able to detect their IP address, and fixes a wide variety of other bugs to get us much closer to a stable release.</p>

<p><a href="https://www.torproject.org/download/download" rel="nofollow">https://www.torproject.org/download/download</a></p>

<p>Packages will be appearing over the next few days.  The original version of this announcement is at <a href="http://archives.seul.org/or/talk/Nov-2010/msg00082.html" rel="nofollow">http://archives.seul.org/or/talk/Nov-2010/msg00082.html</a>.</p>

<p>Changes in version 0.2.2.18-alpha - 2010-11-16<br />
  o Major bugfixes:<br />
    - Do even more to reject (and not just ignore) annotations on<br />
      router descriptors received anywhere but from the cache. Previously<br />
      we would ignore such annotations at first, but cache them to disk<br />
      anyway. Bugfix on 0.2.0.8-alpha. Found by piebeer.<br />
    - Do not log messages to the controller while shrinking buffer<br />
      freelists. Doing so would sometimes make the controller connection<br />
      try to allocate a buffer chunk, which would mess up the internals<br />
      of the freelist and cause an assertion failure. Fixes bug 1125;<br />
      fixed by Robert Ransom. Bugfix on 0.2.0.16-alpha.<br />
    - Learn our external IP address when we're a relay or bridge, even if<br />
      we set PublishServerDescriptor to 0. Bugfix on 0.2.0.3-alpha,<br />
      where we introduced bridge relays that don't need to publish to<br />
      be useful. Fixes bug 2050.<br />
    - Maintain separate TLS contexts and certificates for incoming and<br />
      outgoing connections in bridge relays. Previously we would use the<br />
      same TLS contexts and certs for incoming and outgoing connections.<br />
      Bugfix on 0.2.0.3-alpha; addresses bug 988.<br />
    - Maintain separate identity keys for incoming and outgoing TLS<br />
      contexts in bridge relays. Previously we would use the same<br />
      identity keys for incoming and outgoing TLS contexts. Bugfix on<br />
      0.2.0.3-alpha; addresses the other half of bug 988.<br />
    - Avoid an assertion failure when we as an authority receive a<br />
      duplicate upload of a router descriptor that we already have,<br />
      but which we previously considered an obsolete descriptor.<br />
      Fixes another case of bug 1776. Bugfix on 0.2.2.16-alpha.<br />
    - Avoid a crash bug triggered by looking at a dangling pointer while<br />
      setting the network status consensus. Found by Robert Ransom.<br />
      Bugfix on 0.2.2.17-alpha. Fixes bug 2097.<br />
    - Fix a logic error where servers that _didn't_ act as exits would<br />
      try to keep their server lists more aggressively up to date than<br />
      exits, when it was supposed to be the other way around. Bugfix<br />
      on 0.2.2.17-alpha.</p>

<p>  o Minor bugfixes (on Tor 0.2.1.x and earlier):<br />
    - When we're trying to guess whether we know our IP address as<br />
      a relay, we would log various ways that we failed to guess<br />
      our address, but never log that we ended up guessing it<br />
      successfully. Now add a log line to help confused and anxious<br />
      relay operators. Bugfix on 0.1.2.1-alpha; fixes bug 1534.<br />
    - Bring the logic that gathers routerinfos and assesses the<br />
      acceptability of circuits into line. This prevents a Tor OP from<br />
      getting locked in a cycle of choosing its local OR as an exit for a<br />
      path (due to a .exit request) and then rejecting the circuit because<br />
      its OR is not listed yet. It also prevents Tor clients from using an<br />
      OR running in the same instance as an exit (due to a .exit request)<br />
      if the OR does not meet the same requirements expected of an OR<br />
      running elsewhere. Fixes bug 1859; bugfix on 0.1.0.1-rc.<br />
    - Correctly describe errors that occur when generating a TLS object.<br />
      Previously we would attribute them to a failure while generating a<br />
      TLS context. Patch by Robert Ransom. Bugfix on 0.1.0.4-rc; fixes<br />
      bug 1994.<br />
    - Enforce multiplicity rules when parsing annotations. Bugfix on<br />
      0.2.0.8-alpha. Found by piebeer.<br />
    - Fix warnings that newer versions of autoconf produced during<br />
      ./autogen.sh. These warnings appear to be harmless in our case,<br />
      but they were extremely verbose. Fixes bug 2020.</p>

<p>  o Minor bugfixes (on Tor 0.2.2.x):<br />
    - Enable protection of small arrays whenever we build with gcc<br />
      hardening features, not only when also building with warnings<br />
      enabled. Fixes bug 2031; bugfix on 0.2.2.14-alpha. Reported by keb.</p>

<p>  o Minor features:<br />
    - Make hidden services work better in private Tor networks by not<br />
      requiring any uptime to join the hidden service descriptor<br />
      DHT. Implements ticket 2088.<br />
    - Rate-limit the "your application is giving Tor only an IP address"<br />
      warning. Addresses bug 2000; bugfix on 0.0.8pre2.<br />
    - When AllowSingleHopExits is set, print a warning to explain to the<br />
      relay operator why most clients are avoiding her relay.<br />
    - Update to the November 1 2010 Maxmind GeoLite Country database.</p>

<p>  o Code simplifications and refactoring:<br />
    - When we fixed bug 1038 we had to put in a restriction not to send<br />
      RELAY_EARLY cells on rend circuits. This was necessary as long<br />
      as relays using Tor 0.2.1.3-alpha through 0.2.1.18-alpha were<br />
      active. Now remove this obsolete check. Resolves bug 2081.<br />
    - Some options used different conventions for uppercasing of acronyms<br />
      when comparing manpage and source. Fix those in favor of the<br />
      manpage, as it makes sense to capitalize acronyms.<br />
    - Remove the torrc.complete file. It hasn't been kept up to date<br />
      and users will have better luck checking out the manpage.<br />
    - Remove the obsolete "NoPublish" option; it has been flagged<br />
      as obsolete and has produced a warning since 0.1.1.18-rc.<br />
    - Remove everything related to building the expert bundle for OS X.<br />
      It has confused many users, doesn't work right on OS X 10.6,<br />
      and is hard to get rid of once installed. Resolves bug 1274.</p>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/releases">
          releases
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-8418"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-8418" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">November 18, 2010</p>
    </div>
    <a href="#comment-8418">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-8418" class="permalink" rel="bookmark">Please add tor to qemu or</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Please add tor to qemu or virtualbox. whole security system<br />
(only tcp)</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-8419"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-8419" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">November 18, 2010</p>
    </div>
    <a href="#comment-8419">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-8419" class="permalink" rel="bookmark">Hi. Long time TOR user here.</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Hi. Long time TOR user here. No expert package in download archives yet?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-8424"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-8424" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">November 18, 2010</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-8419" class="permalink" rel="bookmark">Hi. Long time TOR user here.</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-8424">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-8424" class="permalink" rel="bookmark">Read the final paragraph:</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Read the final paragraph: </p>
<p>"Remove everything related to building the expert bundle for OS X. It has confused many users, doesn't work right on OS X 10.6, and is hard to get rid of once installed. Resolves bug 1274."</p>
<p>Don't hold your breath for something they've decided to stop providing.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-8428"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-8428" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">November 19, 2010</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-8419" class="permalink" rel="bookmark">Hi. Long time TOR user here.</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-8428">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-8428" class="permalink" rel="bookmark">I&#039;m also waiting on an</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I'm also waiting on an expert package.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-8435"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-8435" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">November 21, 2010</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-8419" class="permalink" rel="bookmark">Hi. Long time TOR user here.</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-8435">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-8435" class="permalink" rel="bookmark">Seems to be there if you</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Seems to be there if you modify the URL to read: <a href="https://www.torproject.org/dist/win32/tor-0.2.2.18-alpha-win32.exe" rel="nofollow">https://www.torproject.org/dist/win32/tor-0.2.2.18-alpha-win32.exe</a></p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-8427"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-8427" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">November 19, 2010</p>
    </div>
    <a href="#comment-8427">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-8427" class="permalink" rel="bookmark">Hi Anon, you can get any</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Hi Anon, you can get any package you desire from: <a href="http://www.torproject.org/dist/" rel="nofollow">http://www.torproject.org/dist/</a></p>
<p>This version of Tor is running very well here, with:<br />
openssl-1.0.0b<br />
zlib-1.2.5<br />
libevent-2.0.8-rc</p>
<p>Fronted by...<br />
polipo-1.0.4.1</p>
<p>I'm a very very happy customer... :-)</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-8429"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-8429" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">November 19, 2010</p>
    </div>
    <a href="#comment-8429">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-8429" class="permalink" rel="bookmark">I use windows 2000 i cant</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>I use windows 2000 i cant use the new versions of TOR, i dondt no why is not well funktion. Can some one tell me what i must download that i can use the new version?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-8437"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-8437" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">November 22, 2010</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-8429" class="permalink" rel="bookmark">I use windows 2000 i cant</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-8437">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-8437" class="permalink" rel="bookmark">There was information posted</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>There was information posted in this thread off the main page some time ago:<br />
<a href="https://blog.torproject.org/blog/vidalia-0210-released#comments" rel="nofollow">https://blog.torproject.org/blog/vidalia-0210-released#comments</a></p>
<p>There was help for win2k users also posted, by phobos:<br />
"""<br />
Vidalia doesn't work in Win2k because of a winsock dll bug in Win2K.</p>
<p>The explanation for it here:</p>
<p><a href="http://msdn.microsoft.com/en-us/library/ms737931" rel="nofollow">http://msdn.microsoft.com/en-us/library/ms737931</a></p>
<p>If you don't want to recompile Vidalia yourself, this site offers a replacement<br />
dll (with source) that appears to work:</p>
<p><a href="http://codemagnet.blogspot.com/2007/10/winsock2-replacement.html" rel="nofollow">http://codemagnet.blogspot.com/2007/10/winsock2-replacement.html</a><br />
<a href="http://martin.brenner.de/files/winsock2_getaddrinfo.rar" rel="nofollow">http://martin.brenner.de/files/winsock2_getaddrinfo.rar</a><br />
"""</p>
<p>I hope this helps... please update this thread on your progress.</p>
<p>Basically, Win2k can work with the Tor stack it seems.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-8432"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-8432" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">November 21, 2010</p>
    </div>
    <a href="#comment-8432">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-8432" class="permalink" rel="bookmark">i couldn&#039;t find the</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>i couldn't find the installer !!!!!!!!!</p>
<p>it's not in the package</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-8439"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-8439" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">November 23, 2010</p>
    </div>
    <a href="#comment-8439">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-8439" class="permalink" rel="bookmark">Tor felt slower during the</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Tor felt slower during the last weeks.<br />
Your graph "Time in seconds to complete 5 MiB request" at<br />
<a href="http://metrics.torproject.org/performance.html?graph=torperf&amp;start=&amp;end=&amp;filesize=5mb" rel="nofollow">http://metrics.torproject.org/performance.html?graph=torperf&amp;start=&amp;end…</a><br />
shows that download times nearly doubled. Is this due to changes in recent releases?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-8441"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-8441" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">November 25, 2010</p>
    </div>
    <a href="#comment-8441">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-8441" class="permalink" rel="bookmark">Anyone know if theres an</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Anyone know if theres an option in tor i would call it "dynamic exclude list" so it would exclude exit/entry/middle nodes during seeting up new circuits based on specific cryteria, like circuit uptime, connected ips, idle time etc.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-8447"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-8447" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">November 26, 2010</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-8441" class="permalink" rel="bookmark">Anyone know if theres an</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-8447">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-8447" class="permalink" rel="bookmark">What an interesting idea !</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>What an interesting idea !</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-8450"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-8450" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">November 27, 2010</p>
    </div>
    <a href="#comment-8450">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-8450" class="permalink" rel="bookmark">Hello. This is OT, and I</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Hello. This is OT, and I apologize in advance. I'm certain that everyone on here is by now aware that US DHS has begun "seizing" (their word) web sites by rewriting the site DNS records to point to an IP address of their choosing. They claim to be doing this because of copyright violations, but there is every reason to suspect that this is just the beginning of web censorship by US authorities of sites they deem objectionable (5 gets you 10 the next target is wikileaks.org). While this does not impact the function and purpose of Tor per se, there is little point in a tool that provides anonymous access to only non-controversial sites. So, my questions are: 1] is there any aspect of Tor (alternate DNS, etc.) that renders its users less affected by this tactic; 2] Is there any pre-existing non-Tor-project DNS alternative that could be used to circumvent this; 3] Is there any alternative strategy based on technology that exists as part of or because of the Tor project that could be quickly pressed into service to circumvent it? Any other recommendations or observations are welcome. I have begun archiving DNS records for sites that I value that I think could be next on DHS' hit list for my own use, but this really is an issue to which the only possible effective response will be a group effort of some kind. Thank you.</p>
</div>
  </div>
</article>
<!-- Comment END -->
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
